#ifndef MANAGER_H
#define MANAGER_H

#include "employee.h"
#include <iostream>
#include <string>

/**      Manager einer Verkaufsstelle
*/
class Manager : public Employee
{
    public:
        /** Parameter constructor
         @param[in]  name  Name des Angestellten
         @param[in]  wageWeek Wochengehalt
        */
        Manager(const std::string& name, float wageWeek);

        Manager(Manager const&)            = default;     // copy constructor
        Manager(Manager&&)                 = default;     // move constructor
        Manager& operator=(Manager const&) = default;     // copy assignment operator
        Manager& operator=(Manager &&)     = default;     // move assignment operator

        /** Default destructor */
        virtual ~Manager() override;

        /**  Gibt die Daten der aktuellen Instanz aus.
           @param[in,out] s  Ausgabestrom
        */
        void print(std::ostream& s) const override;

        /**  Berechnet das Gehalt.
           @return  Gehalt.
        */
        float payment() const override {return _wageWeek;}
    protected:
    private:
        float _wageWeek; //!< Wochengehalt
};

#endif // MANAGER_H
