#ifndef WORKER_H
#define WORKER_H

#include "employee.h"
#include <iostream>
#include <string>

/**      Normaler Arbeiter (Packer) in einer Verkaufsstelle.
*/
class Worker : public Employee
{
    public:
        /** Parameter constructor
         @param[in]  name  Name des Angestellten
         @param[in]  hours Arbeitsstunden
         @param[in]  wageHours  Stundenlohn
        */
        Worker(const std::string& name, float hours, float wageHours);

        Worker(Worker const&)            = default;     // copy constructor
        Worker(Worker&&)                 = default;     // move constructor
        Worker& operator=(Worker const&) = default;     // copy assignment operator
        Worker& operator=(Worker &&)     = default;     // move assignment operator

        /** Default destructor */
        ~Worker() override;

        /**  Gibt die Daten der aktuellen Instanz aus.
           @param[in,out] s  Ausgabestrom
        */
        void print(std::ostream& s) const override;

        /**  Berechnet das Gehalt.
           @return  Gehalt.
        */
        float payment() const override
            {return _hours*_wageHours ; }
    protected:
    private:
        float _hours; //!< Arbeitsstunden
        float _wageHours; //!< Member Stundenlohn
};

#endif // WORKER_H
